import { TableColumnsType } from "antd";
import { Student } from "../../types/Student";
import { FaPlus } from "react-icons/fa";
import useModalHandler from "../../utils/useModalHandler";
import { ModalEnum } from "../../enums/Model";
import { useObjectToEdit } from "../../zustand/ObjectToEditState";
import { useTranslation } from "react-i18next";
import { useNavigate } from "react-router-dom";
import {
  canAddStudent,
  canDeleteStudent,
  canEditStudent,
  canShowStudent,
} from "../../utils/hasAbilityFn";
import ActionButtons from "../../Components/Table/ActionButtons";
import ColumnsImage from "../../Components/Columns/ColumnsImage";

export const useColumns = () => {
  const { handel_open_model } = useModalHandler();

  const { setObjectToEdit } = useObjectToEdit((state) => state);
  const navigate = useNavigate();

  const handelShow = (record: Student) => {
    navigate(`${record?.id}`);
  };

  const handelDelete = (data: Student) => {
    setObjectToEdit(data);
    handel_open_model(ModalEnum?.STUDENT_DELETE);
  };

  const handleEdit = (record: Student) => {
    setObjectToEdit(record);
    handel_open_model(ModalEnum?.STUDENT_EDIT);
  };
  const [t] = useTranslation();

  const columns: TableColumnsType<Student> = [
    {
      title: t("columns.id"),
      dataIndex: "id",
      key: "id",
      align: "center",
      render: (_text, record) => record?.id,
    },
    {
      title: `${t("columns.name")}`,
      dataIndex: "name",
      key: "name",
      align: "center",
      render: (_text, record) => record?.first_name,
    },
    {
      title: canAddStudent ? (
        <button
          onClick={() => handel_open_model(ModalEnum?.STUDENT_ADD)}
          className="add_button"
        >
          {t("practical.add")} {t("models.student")} <FaPlus />
        </button>
      ) : (
        ""
      ),

      key: "actions",
      align: "end",
      width: "25vw",
      render: (_text, record, index) => {
        return (
          <ActionButtons
            canDelete={canDeleteStudent}
            canEdit={canEditStudent}
            canShow={canShowStudent}
            index={index}
            onDelete={() => handelDelete(record)}
            onEdit={() => handleEdit(record)}
            onShow={() => handelShow(record)}
          />
        );
      },
    },
  ];

  return columns;
};
